#!/usr/bin/perl -w

# Script to post-process BBL output from unsrthtml.bst bibTeX style.
# Author: Han-Kwang Nienhuys

$basename = "mypubhtml"; # basename for .tex file


system("rm -f $basename.bbl");
system("latex $basename && bibtex $basename");
system("mv $basename.bbl tmp__");

open(FH, "tmp__") || die("tmp__:$!");
@lines = <FH>;
close(FH);

$text = join("", @lines);

# replace some common LaTeX constructs (superscripts, subscripts)

$text =~ s|~|&nbsp;|g;
$text =~ s|([^!])--([^>])|$1-$2|g;
$text =~ s|_([^{])|<sub>$1</sub>|g;
$text =~ s|\^([^{])|<sup>$1</sup>|g;
$text =~ s|_\{([^}]*)\}|<sub>$1</sub>|g;
$text =~ s|\^\{([^}]*)\}|<sup>$1</sup>|g;
$text =~ s|([^\\])\$|$1|g;
$text =~ s|[{}]||g;

# put in years

$prevyear = -1;
@lines = split("\n", $text);
$text = "";
foreach $x (@lines) {
    # extract year of publication
    if ($x =~ m/<!-- y=[0-9]{4}/) {
	$y = $x;
	$y =~ s/^.*-- y=([0-9]{4}).*$/$1/;
	if  ($y != $prevyear) {
	    if ($prevyear != -1) {
		$text .= "</ul>";
	    }
	    $text .= "\n<h2>$y</h2><ul>\n";
	    $prevyear =$y;
	}
    }
    $text .= "$x\n";
}

open(FH, ">$basename.html") || die("$basename.html: $!");
print(FH $text);
close(FH);

print("\nHTML output is now in $basename.html\n");



